%global momorel 1

Summary: The CMU Common Lisp compiler.
Name: 	 cmucl
Version: 19d
Release: %{momorel}m%{?dist}
License: Public Domain
Group: 	 Development/Languages
URL:	 http://www.cons.org/cmucl/
%NoSource 0 http://common-lisp.net/project/cmucl/downloads/release/%{version}/cmucl-src-%{version}.tar.bz2 3a3dba371a7e1db7fa4b8f338acd72a3
%NoSource 1 http://common-lisp.net/project/cmucl/downloads/release/%{version}/patches/cmucl-%{version}-patch-001.tar.gz 07607ea26491df0ce1c70e411ddfb64d
%NoSource 2 http://common-lisp.net/project/cmucl/downloads/release/%{version}/patches/cmucl-%{version}-patch-002.tar.gz e5db107d352b9da1535db7f85a541842
# Existing cmucl binary for bootstrap
%NoSource 10 http://common-lisp.net/project/cmucl/downloads/release/%{version}/cmucl-%{version}-x86-linux.tar.bz2 802cd8b05e376ff04c9006dd04f5bc7e
# Currently not included/packaged
#Source100: ftp://cmucl.cons.org/pub/lisp/cmucl/doc/EncyCMUCLopedia/encycmuclopedia-20010617.tar.bz2
Patch1: cmucl-19-motif.patch
BuildRequires: perl
BuildRequires: openmotif-devel
Buildroot: %{_tmppath}/%{name}-%{version}-root
ExclusiveArch: %{ix86}

%description
CMU Common Lisp is public domain "industrial strength"
Common Lisp programming environment.  Many of the X3j13 changes have
been incorporated into CMU CL.  Wherever possible, this has been done
so as to transparently allow use of either CLtL1 or proposed ANSI CL.
Probably the new features most interesting to users are SETF
functions, LOOP and the WITH-COMPILATION-UNIT macro.

%prep
%setup -q -c -a 10 -a 2 -a 1
#-a 10
%patch1 -p1 -b .sharedmotif

## Fix up build-tools
##perl -pi -e 's@\$TARGET/pcl@src/pcl@' build-tools/make*dist.sh


%build
export RPM_OPT_FLAGS="%{optflags}"

# Create target buildroot
src/tools/create-target.sh %{_target_platform} linux_gencgc x86
# Use binary-dist lisp to create initial kernel.core 
src/tools/build-world.sh %{_target_platform} bin/lisp
# build native lisp binary
src/tools/rebuild-lisp.sh %{_target_platform} 
# Generate lisp.core
src/tools/load-world.sh %{_target_platform} "%{version} Momonga release %{release}"
# rebuild kernel.core using native lisp 
src/tools/build-world.sh %{_target_platform} %{_target_platform}/lisp/lisp
# (Re)generate lisp.core
src/tools/load-world.sh %{_target_platform} "%{version} Momonga release %{release}"
# Build auxilary stuff
src/tools/build-utils.sh %{_target_platform} 
# make new binary dist archives
src/tools/make-dist.sh %{_target_platform} %{version} x86 linux


%install
rm -rf %{buildroot}

mkdir -p dist
pushd dist
# unarchive newly creating binary dist archives
tar xvzf ../cmucl-%{version}-x86-linux.tar.gz
tar xvzf ../cmucl-%{version}-x86-linux.extra.tar.gz

mkdir -p %{buildroot}%{_libdir}/cmucl/
cp -a bin %{buildroot}%{_libdir}/cmucl/
cp -a lib/cmucl %{buildroot}%{_libdir}/

mkdir -p %{buildroot}%{_mandir}/man1
install -p man/man1/* %{buildroot}%{_mandir}/man1
popd dist

## Setup app-wrapper
install -m755 -p -D lib/cmucl/sample-wrapper %{buildroot}%{_bindir}/cmucl
# Fixup paths in wrapper
perl -pi -e "s|^CMUCLLIB=.*|CMUCLLIB=%{_libdir}/cmucl/lib|" %{buildroot}%{_bindir}/cmucl
perl -pi -e "s|/<<your-cmucl-path>>|%{_libdir}/cmucl|"      %{buildroot}%{_bindir}/cmucl
# many apps (ie, maxima) expect to find the wrapper named 'lisp' too
ln -sf cmucl %{buildroot}%{_bindir}/lisp

%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root)
%doc doc/cmucl/README doc/cmucl/release*.txt
%doc cmucl-%{version}-patch-001
%{_bindir}/cmucl
%{_bindir}/lisp
%dir %{_libdir}/cmucl
%{_libdir}/cmucl/internals.inc
%{_libdir}/cmucl/bin
%dir %{_libdir}/cmucl/lib
%{_libdir}/cmucl/lib/lisp.core
%{_libdir}/cmucl/lib/load-foreign.csh
%{_libdir}/cmucl/lib/config
%{_libdir}/cmucl/lib/config.lisp
%{_libdir}/cmucl/lib/generic-site.lisp
%dir %{_libdir}/cmucl/lib/subsystems
%{_libdir}/cmucl/lib/subsystems/gray-*-library.x86f
%{_libdir}/cmucl/lib/subsystems/iodefs-library.x86f
%{_libdir}/cmucl/lib/subsystems/simple-*-library.x86f
%{_libdir}/cmucl/lisp.nm
%{_libdir}/cmucl/lisp.map
%{_libdir}/cmucl/internals.h
%{_libdir}/cmucl/sample-wrapper
%{_mandir}/man1/*
%{_libdir}/cmucl/lib/subsystems/clx-library.x86f
%{_libdir}/cmucl/lib/subsystems/hemlock-library.x86f
%{_libdir}/cmucl/lib/subsystems/clm-library.x86f
%{_libdir}/cmucl/lib/XKeysymDB
%{_libdir}/cmucl/lib/hemlock11.cursor
%{_libdir}/cmucl/lib/hemlock11.mask
%{_libdir}/cmucl/lib/spell-dictionary.bin
%{_libdir}/cmucl/lib/mh-scan
%{_libdir}/cmucl/lib/motifd

%changelog
* Thu May 24 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (19d-1m)
- update 19d
- change Source URL

* Mon Nov 13 2006 Masayuki SANO <nosanosa@momonga-linux.org>
- (19c-2m)
- rebuild against openmotif-2.3.0-beta2

* Wed Jan 11 2006 Yohsuke Ooi <meme@momonga-linux.org> 
- (19c-1m)
- update 19c

* Sun Oct 31 2004 Masayuki SANO <nosanosa@momonga-linux.org> 
- (19a-1m)
- first import to Momonga
- import from http://apt.kde-redhat.org/kde-redhat/fedora/all/SRPMS.stable/

* Thu Aug 26 2004 Rex Dieter <rexdieter at sf.net> 0:19-0.fdr.2.a
- Fix Release: 19e -> 19a

* Wed Aug 04 2004 Rex Dieter <rexdieter at sf.net> 0:19-0.fdr.1.a
- cmucl-19a release
- nix -extras subpkg, for now

* Tue Mar 30 2004 Rex Dieter <rexdieter at sf.net> 0:18-0.fdr.2.e
- remove extraneous macros
- include URL's for all Source's.

* Fri Oct 10 2003 Rex Dieter <rexdieter at sf.net> 0:18-0.fdr.1.e
- first try.


